﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using tom;
namespace tstopc_cs
{
    public class CTstdata
    {
        public  bool  SetItemVal(string sTagName,ref object pval, ushort wqa,long filetime,System.IntPtr pCallBackArg) // 写标签值
	    {
		    //这里只是简单的写到opcserver,实际可根据情况写到现场设备
		    return (Opcsrv.opcsrv_setval(sTagName,ref pval,wqa,filetime) != Opcsrv.OE_OK);
	    }
        public void AddTag()//添加测试标签
        {
            //只读标签
            Opcsrv.opcsrv_addtag("r_i32", "des_ri32", "unit_ri32", Opcsrv.ODT_I32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("r_i64", "des_ri64", "unit_ri64", Opcsrv.ODT_I64, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("r_f32", "des_rf32", "unit_rf32", Opcsrv.ODT_F32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("r_f64", "des_rf64", "unit_rf64", Opcsrv.ODT_F64, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("r_str", "des_rstr", "unit_rstr", Opcsrv.ODT_STR, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("r_blob", "des_rblob", "unit_blob", Opcsrv.ODT_BLOB, Opcsrv.OTEM_NOWRITE);

            //可写标签
            Opcsrv.opcsrv_addtag("w_i32", "des_wi32", "unit_wi32", Opcsrv.ODT_I32, Opcsrv.OTEM_WRITE);
            Opcsrv.opcsrv_addtag("w_i64", "des_wi64", "unit_wi64", Opcsrv.ODT_I64, Opcsrv.OTEM_WRITE);
            Opcsrv.opcsrv_addtag("w_f32", "des_wf32", "unit_wf32", Opcsrv.ODT_F32, Opcsrv.OTEM_WRITE);
            Opcsrv.opcsrv_addtag("w_f64", "des_wf64", "unit_wf64", Opcsrv.ODT_F64, Opcsrv.OTEM_WRITE);
            Opcsrv.opcsrv_addtag("w_str", "des_wstr", "unit_wstr", Opcsrv.ODT_STR, Opcsrv.OTEM_WRITE);
            Opcsrv.opcsrv_addtag("w_blob", "des_wblob", "unit_wblob", Opcsrv.ODT_BLOB, Opcsrv.OTEM_WRITE);

            //以下测试标签分级查询
            Opcsrv.opcsrv_addtag("factory1.device1.r_i32", "des_ri32", "unit_ri32", Opcsrv.ODT_I32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("factory1.device1.r_f32", "des_rf32", "unit_rf32", Opcsrv.ODT_F32, Opcsrv.OTEM_NOWRITE);

            Opcsrv.opcsrv_addtag("factory1.device2.r_i32", "des_ri32", "unit_ri32", Opcsrv.ODT_I32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("factory1.device2.r_f32", "des_rf32", "unit_rf32", Opcsrv.ODT_F32, Opcsrv.OTEM_NOWRITE);

            Opcsrv.opcsrv_addtag("factory2.device1.r_i32", "des_ri32", "unit_ri32", Opcsrv.ODT_I32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("factory2.device1.r_f32", "des_rf32", "unit_rf32", Opcsrv.ODT_F32, Opcsrv.OTEM_NOWRITE);

            Opcsrv.opcsrv_addtag("factory2.device2.r_i32", "des_ri32", "unit_ri32", Opcsrv.ODT_I32, Opcsrv.OTEM_NOWRITE);
            Opcsrv.opcsrv_addtag("factory2.device2.r_f32", "des_rf32", "unit_rf32", Opcsrv.ODT_F32, Opcsrv.OTEM_NOWRITE);

        }
        public void SimuVal(long t)//模拟值
	    {
            object val =new object() ;
            val = (int)(t % 10000);
		    Opcsrv.opcsrv_setval("r_i32",ref val,Opcsrv.OPC_QUALITY_GOOD,(long)0);
            Opcsrv.opcsrv_setval("factory1.device1.r_i32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory1.device2.r_i32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory2.device1.r_i32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory2.device2.r_i32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);

            val = (float)((t%10000)/100.0);
		    Opcsrv.opcsrv_setval("r_f32",ref val,Opcsrv.OPC_QUALITY_GOOD,0);
            Opcsrv.opcsrv_setval("factory1.device1.r_f32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory1.device2.r_f32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory2.device1.r_f32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
            Opcsrv.opcsrv_setval("factory2.device2.r_f32", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);

            val =  t;
		    Opcsrv.opcsrv_setval("r_i64",ref val,Opcsrv.OPC_QUALITY_GOOD,0);

		    val = (t%1000000)/1000.0;
		    Opcsrv.opcsrv_setval("r_f64",ref val,Opcsrv.OPC_QUALITY_GOOD,0);

            string stime = DateTime.Now.ToString("yyyy-MM-dd hh:mm:ss");
            val = stime;
            Opcsrv.opcsrv_setval("r_str", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);

            byte[] bytes= Encoding.UTF8.GetBytes(stime);
            val = bytes;
            Opcsrv.opcsrv_setval("r_blob", ref val, Opcsrv.OPC_QUALITY_GOOD, 0);
	    }
    }
}
