﻿Public Class Form1
    Dim isopcrun As Integer = 0 '是否运行

    Dim g_sClsID As String = "{7ADCBB57-943C-4D32-B4D6-365221DEF221}" '唯一的GUID，用VS工具GUID生成
    Dim g_sVendor As String = "tom" '公司简称
    Dim g_sDrivername As String = "opctst_vbw32" '驱动简称
    Dim g_sVersion As String = "1" '版本
    Dim g_sOpcServerDes As String = "opc server dll test use vb" '描述

    Public Function onSetItemVal(
            ByVal sTagName As String,
            ByRef pval As Object,
            ByVal wqa As UShort,
            ByVal filetime As Long,
            ByVal pCallBackArg As System.IntPtr
            ) As Boolean
        opcsrv_da.fun.opcsrv_setval(sTagName, pval, wqa, filetime) '回调函数，这里只是简单的写入到OPCSRV，如果要写入到现场设备，可以在这里处理
        Return True
    End Function

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim nret As Integer
        Dim cmdstring As String
        cmdstring = Command()
        cmdstring = Trim(cmdstring)
        If (cmdstring = "-reg" Or cmdstring = "/reg") Then  '注册
            nret = opcsrv_da.fun.opcsvr_reg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, 0)
            If (nret <> 0) Then
                MsgBox("reg error")
            Else
                MsgBox("reg success")
            End If
            End '结束程序,注册只运行一次。
        ElseIf (cmdstring = "-unreg" Or cmdstring = "/unreg") Then '卸载
            nret = opcsrv_da.fun.opcsvr_unreg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes)

            If (nret <> 0) Then
                MsgBox("unreg error")
            Else
                MsgBox("unreg success")
            End If
            End '结束程序，卸载也只需运行一次
        Else '启动运行,不带命令行参数正常运行
            opcsrv_da.fun.opcsrv_addtag("tst.r_f32", "test read tag", "Kw", opcsrv_da.def.ODT_F32, opcsrv_da.def.OTEM_NOWRITE) '添加一个只读标签，这个标签值在定时器中定时更新
            opcsrv_da.fun.opcsrv_addtag("tst.w_i32", "test rw tag", "Kw", opcsrv_da.def.ODT_I32, opcsrv_da.def.OTEM_WRITE) '添加一个可读写标签,你可以添加更多标签
            If (0 <> opcsrv_da.fun.opcsrv_start(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, AddressOf onSetItemVal, 0, 0)) Then '启动运行,不锁定
                MsgBox("opcsrv_start failed!")
                End '结束程序
            End If
            isopcrun = 1
        End If

    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If (isopcrun <> 0) Then
            opcsrv_da.fun.opcsrv_stop() '停止
        End If
    End Sub


    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        If (isopcrun <> 0) Then
            Dim val As Double
            val = DateTime.UtcNow.Second * 0.1 '模拟产生r_f32标签的数据
            opcsrv_da.fun.opcsrv_setval("tst.r_f32", val, opcsrv_da.def.OPC_QUALITY_GOOD, DateTime.UtcNow.ToFileTime)
        End If
    End Sub
End Class
